#include <iostream>
#include <vector>
#include "histogram.h"

using namespace std;

const size_t SCREEN_WIDTH = 80;
const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;

struct Input {
    vector<double> numbers;
    size_t bin_count{};
};

Input input_data()
{
    size_t number_count;
    cerr << "Enter number count:";
    cin >> number_count;

Input in;

    in.numbers.resize(number_count);
    cerr << "Enter numbers: ";
    for(size_t i = 0; i < number_count; i++)
        cin >> in.numbers[i];

    cerr << "Enter number of bins: ";
    cin >> in.bin_count;

    return in;

}

void find_minmax(vector<double>& numbers, double& min, double& max) {
    min = numbers[0];
    max = numbers[0];
    // (    )
    for (double x : numbers){
        if (x < min){
            min = x;
        } else if (x > max){
            max = x;
        }
    }
}

vector<size_t> make_histogram(vector<double> &numbers, size_t bin_count) {
    double min = numbers[0];
    double max = numbers[0];
    find_minmax(numbers, min, max);

    double bin_size = (max - min) / bin_count;
    vector<size_t> bins (bin_count);

    for (size_t i=0; i < numbers.size(); i++ ){
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++){
            auto lo = min + j * bin_size;
            auto hi = min + ( j + 1 ) * bin_size;

            if (lo <= numbers[i] && (numbers[i] < hi)){
                bins[j]++;
                found = true;
            }
        }
        if (!found){
            bins[bin_count-1]++;
        }
    }
    return bins;
}
void show_histogram_text(vector<size_t> &bins){
   size_t maxbin = bins[0];
    for (size_t i=1; i < bins.size(); i++){
        if (maxbin < bins[i]){
            maxbin = bins[i];
        }
    }
}
int main()
{
    Input in = input_data();
    auto bins = make_histogram(in.numbers, in.bin_count);
    show_histogram_text(bins);

    size_t maxbin = bins[0];
    for (size_t i=1; i < in.bin_count; i++){
        if (maxbin < bins[i]){
            maxbin = bins[i];
        }
    }
    if (maxbin <= MAX_ASTERISK){
        for (size_t i=0; i < in.bin_count; i++){
            if ((bins[i] < 1000)&&(bins[i] > 99)){
                cout << bins[i] << "|";
                for ( size_t j=0; j < bins[i]; j++ ){
                    cout << "*";
                }
            cout << endl;

            } else if ((bins[i] < 100)&&(bins[i]>9)) {
                cout << " " << bins[i] << "|";
                for ( size_t j=0; j < bins[i]; j++ ){
                    cout << "*";
                }
            cout << endl;

            } else if ( bins[i] < 10 ){
                cout << "  " << bins[i]<< "|";
                for ( size_t j=0; j < bins[i]; j++ ){
                    cout << "*";
                }
                cout << endl;
            }
        }
    } else {
        for (size_t i=0; i < in.bin_count; i++){
            size_t heightG= MAX_ASTERISK * (static_cast<double>(bins[i]) / maxbin);

            if ((bins[i] < 1000)&&(bins[i] > 99)){
                cout << bins[i] << "|";
                for ( size_t j=0; j < heightG; j++ ){
                    cout << "*";
                }
                cout << endl;

            } else if ((bins[i] < 100)&&(bins[i]>9)) {
                cout << " " << bins[i] << "|";
                for (size_t j=0; j < heightG; j++){
                    cout << "*";
                }
                cout << endl;

            } else if (bins[i] < 10){
                cout << "  " << bins[i]<< "|";

                for (size_t j=0; j < heightG; j++){
                    cout << "*";
                }
                cout << endl;
            }
        }
    }
}


